// contest6.cpp : Defines the entry point for the console application.
/*
Use as you will
c++ is not a language I program in normally I much prefer Delphi, so this 
could be very badly written, but it does what I need/want it to!

here's the code in Visual C++ 2008 Express Edition
*/

#include "stdafx.h"
#include <pcap.h>
#include <time.h>
#include <winsock2.h>
#include <windows.h>
#include <string>


#define LINE_LEN 16

using std::string;

/* 4 bytes IP address */
typedef struct ip_address{
    u_char byte1;
    u_char byte2;
    u_char byte3;
    u_char byte4;
}ip_address;

/* IPv4 header */
typedef struct ip_header{
    u_char  ver_ihl;        // Version (4 bits) + Internet header length (4 bits)
    u_char  tos;            // Type of service 
    u_short tlen;           // Total length 
    u_short identification; // Identification
    u_short flags_fo;       // Flags (3 bits) + Fragment offset (13 bits)
    u_char  ttl;            // Time to live
    u_char  proto;          // Protocol
    u_short crc;            // Header checksum
    ip_address  saddr;      // Source address
    ip_address  daddr;      // Destination address
    u_int   op_pad;         // Option + Padding
}ip_header;

/* TCP header */
typedef struct tcp_header{
   u_short src_portno;
   u_short dst_portno;
   u_int tcp_seq;
   u_int tcp_ack;
   u_char offset; // to be used with GenerateOffset
   u_char flags; // to be used with GenerateFlags
   u_short tcp_window;
   u_short tcp_checksum;
   u_short tcp_urp;
}tcp_header;

/* UDP header*/
typedef struct udp_header{
    u_short sport;          // Source port
    u_short dport;          // Destination port
    u_short len;            // Datagram length
    u_short crc;            // Checksum
}udp_header;

/* prototype of the packet handler */
void packet_handler(u_char *param, const struct pcap_pkthdr *header, const u_char *pkt_data);


void GetTCPFlags(u_char data, string &res)
/* convert TCP Flags from Hex to ASCII */
{
	if (data & 0x01) res = res + 'F';
	if (data & 0x02) res = res + 'S';
	if (data & 0x04) res = res + 'R';
	if (data & 0x08) res = res + 'P';
	if (data & 0x10) res = res + 'A';
	if (data & 0x20) res = res + 'U';
	if (data & 0x40) res = res + 'E';
	if (data & 0x80) res = res + 'C';
}


void processPackets(struct pcap_pkthdr *header, const u_char *pkt_data,  char *TCPFlagsList, boolean TCPFlagsCheck, int currentNum)
{
	//not the perfect way to pull the time, but...
	struct tm *ltime;
	char timestr[16];
	time_t local_tv_sec;

	//setup var's for ip, tcp and udp info we'll need
	ip_header *ih;
	udp_header *uh;
	tcp_header *th;
	u_int ip_len;
	u_short sport,dport, ipid;
	u_long seqNum, ackNum;
	string tcpflags="";

	boolean isTCP=false;
	boolean isUDP=false;


    /* print pkt timestamp and pkt len */
	local_tv_sec = header->ts.tv_sec;
	ltime=localtime(&local_tv_sec);
	strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
    
	/* retrieve the position of the ip header */
	ih = (ip_header *) (pkt_data + 14); //length of ethernet header
	ipid = ntohs(ih->identification);

	//check to see if it is UDP
	if (ih->proto == 0x11)
	{
		isUDP=true;
		/* retrieve the position of the udp header */
	    ip_len = (ih->ver_ihl & 0xf) * 4;
		uh = (udp_header *) ((u_char*)ih + ip_len);
		sport = ntohs( uh->sport );
	    dport = ntohs( uh->dport );
	}

	//check to see if it is TCP
	if (ih->proto == 0x06)
	{
		isTCP=true;
		tcpflags = "";
		/* retrieve the position of the tcp header */
	    ip_len = (ih->ver_ihl & 0xf) * 4;
		th = (tcp_header *) ((u_char*)ih + ip_len);
		sport = ntohs( th->src_portno );
		dport = ntohs( th->dst_portno );
		seqNum = ntohl(th->tcp_seq);
		ackNum = ntohl(th->tcp_ack);
		GetTCPFlags(th->flags, tcpflags);
	}


	/* print ip addresses 
	need to verify tcp packets or udp and clean up bad output
	such as ICMP traffic, but for now, don't care
	*/
	if (isTCP)
	{
		if (TCPFlagsCheck)
		{
			if (tcpflags == TCPFlagsList)
			printf("%d %s,%.6d %s %d.%d.%d.%d:%d -> %d.%d.%d.%d:%d %d %.8x %.8x \n",
				currentNum, timestr, header->ts.tv_usec, tcpflags.c_str(),
				ih->saddr.byte1, ih->saddr.byte2, ih->saddr.byte3, ih->saddr.byte4, sport,
				ih->daddr.byte1, ih->daddr.byte2, ih->daddr.byte3, ih->daddr.byte4, dport,
				ipid, seqNum, ackNum);
		}
		else
		{
			printf("%d %s,%.6d %s %d.%d.%d.%d:%d -> %d.%d.%d.%d:%d %d %.8x %.8x \n",
				currentNum, timestr, header->ts.tv_usec, tcpflags.c_str(),
				ih->saddr.byte1, ih->saddr.byte2, ih->saddr.byte3, ih->saddr.byte4, sport,
				ih->daddr.byte1, ih->daddr.byte2, ih->daddr.byte3, ih->daddr.byte4, dport,
				ipid, seqNum, ackNum);
		}
	}
	else if (isUDP) 
	{
		if (!TCPFlagsCheck)
		{
			printf("%d %s,%.6d %d.%d.%d.%d:%d -> %d.%d.%d.%d:%d \n",
				currentNum, timestr, header->ts.tv_usec, 
				ih->saddr.byte1, ih->saddr.byte2, ih->saddr.byte3, ih->saddr.byte4, sport,
				ih->daddr.byte1, ih->daddr.byte2, ih->daddr.byte3, ih->daddr.byte4, dport);
		}
	}
	else //icmp or other protocol so just give the basics
	{
		if (!TCPFlagsCheck)
		{
			printf("%d %s,%.6d %d.%d.%d.%d -> %d.%d.%d.%d \n",
				currentNum, timestr, header->ts.tv_usec, 
				ih->saddr.byte1, ih->saddr.byte2, ih->saddr.byte3, ih->saddr.byte4,
				ih->daddr.byte1, ih->daddr.byte2, ih->daddr.byte3, ih->daddr.byte4);
		}
	}


}

int main(int argc, char **argv)
{
	pcap_t *fp;
	char errbuf[PCAP_ERRBUF_SIZE];
	char source[PCAP_BUF_SIZE];
	char *ofilename=NULL;
	char *filter=NULL;
	bpf_u_int32 NetMask;
	struct bpf_program fcode;
	struct pcap_pkthdr *header;
	const u_char *pkt_data;
	u_int i=0;
	int res, x;
	boolean TCPFlagsCheck = false;
	char *TCPFlagsList;
	int currentNum;

    if(argc == 1)
    {
        printf("usage: %s -r filename -f filter -l TCP Flags [S SA FA ...]", argv[0]);
        return -1;
    }
    
	for(x=1;x < argc; x+= 2)
    {

        switch (argv[x] [1])
        {
            case 'r':
            {
                ofilename=argv[x+1];
            };
            break;

            case 'f':
            {
                filter=argv[x+1];
            };
            break;

            case 'l':
            {
                TCPFlagsList=argv[x+1];
				TCPFlagsCheck=true;
            };
            break;
		}
    }

	if (ofilename == NULL)
	{
		return -1;
	}

    /* Create the source string according to the new WinPcap syntax */
    if ( pcap_createsrcstr( source, PCAP_SRC_FILE, NULL, NULL, ofilename, errbuf) != 0)
    {
        fprintf(stderr,"\nError creating a source string\n");
        return -1;
    }
    
    /* Open the capture file */
    if ( (fp= pcap_open(source, 65536, PCAP_OPENFLAG_PROMISCUOUS, 1000, NULL, errbuf) ) == NULL)
    {
        fprintf(stderr,"\nUnable to open the file %s.\n", source);
        return -1;
    }

	if (filter != NULL)
    {
        NetMask=0xffffff;

        //compile the filter
        if(pcap_compile(fp, &fcode, filter, 1, NetMask) < 0)
        {
            fprintf(stderr,"\nError compiling filter: wrong syntax.\n");
            return -1;
        }

        //set the filter
        if(pcap_setfilter(fp, &fcode)<0)
        {
            fprintf(stderr,"\nError setting the filter\n");
            return -1;
        }

    }

    
	currentNum=1;

	/* Retrieve the packets from the file */
	while((res = pcap_next_ex( fp, &header, &pkt_data)) >= 0)
    {
		processPackets(header, pkt_data, TCPFlagsList, TCPFlagsCheck, currentNum);
		currentNum++;
    }
    
    
    if (res == -1)
    {
        printf("Error reading the packets: %s\n", pcap_geterr(fp));
    }
    
    return 0;
}

